<?php
define('G5_CAPTCHA', true);
include_once('./_common.php');

define('AMINA_FANCYBOX2', true);

if(AMINA == 'g5') {
	include_once(G5_CAPTCHA_PATH.'/captcha.lib.php');
	$point_log = '댓글';
	$captcha_html = "";
	if ($is_guest && $board['bo_comment_level'] < 2) {
	    $captcha_html = captcha_html('_comment');
	}
} else if(AMINA == 'g4s') {
	include_once(G5_CAPTCHA_PATH.'/gcaptcha.lib.php');
	$point_log = '댓글';
} else {
	include_once(AMINA_PATH.'/lib/head.lib.php');
	$point_log = '코멘트';
}

$move_href = false;
if($_POST['js'] != "on") $move_href = true;

function amina_return($error, $wr_id, $frame='') {
	global $g5, $bo_table, $page, $qstr, $go_url;

	if($move_href || $frame) {
		$move_href = $go_url ? $go_url.'&go_url='.urlencode($go_url) : G5_BBS_URL.'/board.php?bo_table='.$bo_table.'&wr_id='.$wr_id.'&page='.$page.$qstr;
		if($error) {
			alert($error, $move_href);
		} else {
		    echo "<script type='text/javascript'> location.replace('$move_href'); </script>";
		    exit;
		}
	} else {
		echo 'error'.$error;
		exit;
	}
}

if($redo) { //새로고침
	$wr = $write;

	if (!$wr['wr_id']) {
		$error = '글이 존재하지 않습니다.\\n\\n글이 삭제되었거나 이동하였을 수 있습니다.';
		amina_return($error, $wr['wr_id'], $frame);
	}

} else {

	if($w == "cd") { //삭제
	
		//댓글
		$write = sql_fetch(" select * from $write_table where wr_id = '$comment_id' ");

		//원글
		$wr = get_write($write_table, $write['wr_parent']);

		if ($is_admin) {
		    if (!($token && get_session("ss_delete_token") == $token)) {
				$error = '토큰 에러로 삭제 불가합니다.';
				amina_return($error, $wr['wr_id']);			
			}
		}

		// 4.1
		@include_once($board_skin_path.'/delete_comment.head.skin.php');

		if (!$write['wr_id'] || !$write['wr_is_comment']) {
			$error = '등록된 댓글이 없거나 댓글이 아닙니다.';
			amina_return($error, $wr['wr_id']);
		}

		if ($is_admin == "super") // 최고관리자 통과
			;
		else if ($is_admin == "group") { // 그룹관리자
			$mb = get_member($write['mb_id']);
		    if ($member['mb_id'] == $group['gr_admin']) { // 자신이 관리하는 그룹인가?
			    if ($member['mb_level'] >= $mb['mb_level']) { // 자신의 레벨이 크거나 같다면 통과
			        ;
			    } else {
					$error = '그룹관리자의 권한보다 높은 회원의 댓글이므로 삭제할 수 없습니다.';
					amina_return($error, $wr['wr_id']);
				}
		    } else {
				$error = '자신이 관리하는 그룹의 게시판이 아니므로 댓글을 삭제할 수 없습니다.';
				amina_return($error, $wr['wr_id']);
			}
		} else if ($is_admin == "board") { // 게시판관리자이면
			$mb = get_member($write['mb_id']);
		    if ($member['mb_id'] == $board['bo_admin']) { // 자신이 관리하는 게시판인가?
			    if ($member['mb_level'] >= $mb['mb_level']) { // 자신의 레벨이 크거나 같다면 통과
				    ;
		        } else {
					$error = '게시판관리자의 권한보다 높은 회원의 댓글은 삭제할 수 없습니다.';
					amina_return($error, $wr['wr_id']);
				}
		    } else {
				$error = '자신이 관리하는 게시판이 아니므로 댓글을 삭제할 수 없습니다.';
				amina_return($error, $wr['wr_id']);
			}
		} else if ($member['mb_id']) {
			if ($member['mb_id'] != $write['mb_id']) {
				$error = '자신의 글이 아니므로 삭제할 수 없습니다.';
				amina_return($error, $wr['wr_id']);
			}
		} else {
			if (sql_password($wr_password) != $write['wr_password']) {
				$error = '패스워드가 틀립니다.';
				amina_return($error, $wr['wr_id']);
			}
		}

		$len = strlen($write['wr_comment_reply']);
		if ($len < 0) $len = 0; 
		$comment_reply = substr($write['wr_comment_reply'], 0, $len);

		$sql = " select count(*) as cnt from $write_table
			      where wr_comment_reply like '$comment_reply%'
				    and wr_id <> '$comment_id'
					and wr_parent = '{$write['wr_parent']}'
		            and wr_comment = '{$write['wr_comment']}' 
			        and wr_is_comment = 1 ";
		$row = sql_fetch($sql);
		if ($row['cnt'] && !$is_admin) {
			$error = '이 댓글과 관련된 답변댓글이 존재하므로 삭제 할 수 없습니다.';
			amina_return($error, $wr['wr_id']);
		}

		// 포인트 삭제
		if (!delete_point($write['mb_id'], $bo_table, $comment_id, $point_log))
			insert_point($write['mb_id'], $board['bo_comment_point'] * (-1), "{$board['bo_subject']} {$write['wr_parent']}-{$comment_id} {$point_log}삭제");

		// 댓글 삭제
		sql_query(" delete from $write_table where wr_id = '$comment_id' ");

		// 댓글이 삭제되므로 해당 게시물에 대한 최근 시간을 다시 얻는다.
		$sql = " select max(wr_datetime) as wr_last from $write_table where wr_parent = '{$write['wr_parent']}' ";
		$row = sql_fetch($sql);
                                      
		// 원글의 댓글 숫자를 감소
		sql_query(" update $write_table set wr_comment = wr_comment - 1, wr_last = '{$row['wr_last']}' where wr_id = '{$write['wr_parent']}' ");

		// 댓글 숫자 감소
		sql_query(" update {$g5['board_table']} set bo_count_comment = bo_count_comment - 1 where bo_table = '$bo_table' ");

		// 새글 삭제
		sql_query(" delete from {$g5['board_new_table']} where bo_table = '$bo_table' and wr_id = '$comment_id' ");

		// 사용자 코드 실행
		@include_once($board_skin_path.'/delete_comment.skin.php');

		// 4.1
		@include_once($board_skin_path.'/delete_comment.tail.skin.php');

		unset($write);

	} else { //댓글 등록 & 수정

		//$wr = get_write($write_table, $wr_id);
		$wr = $write;

		if (!$wr['wr_id']) {
			$error = '글이 존재하지 않습니다.\\n\\n글이 삭제되었거나 이동하였을 수 있습니다.';
			amina_return($error, $wr['wr_id']);
		}

		// 090710
		if (substr_count($wr_content, "&#") > 50) {
			$error = '내용에 올바르지 않은 코드가 다수 포함되어 있습니다.';
			amina_return($error, $wr['wr_id']);
		}

		//SNS 관련 필드 생성
		$wr_keys = array();
		$wr_keys = array_keys($wr);

		if(!in_array('wr_facebook_user', $wr_keys)) {
			sql_query(" alter table $write_table add wr_facebook_user varchar(255) default '' NOT NULL AFTER wr_ip ", false);
			sql_query(" alter table $write_table add wr_twitter_user varchar(255) default '' NOT NULL AFTER wr_facebook_user ", false);
		}

		@include_once($board_skin_path.'/write_comment_update.head.skin.php');

		$w = $_POST['w'];

		if(AMINA) {
			$wr_name  = escape_trim($_POST['wr_name']);
			$wr_email = '';
			if (!empty($_POST['wr_email']))
			    $wr_email = escape_trim($_POST['wr_email']);

			// 비회원의 경우 이름이 누락되는 경우가 있음
			if ($is_guest) {
			    if ($wr_name == '') {
					$error = '이름은 필히 입력하셔야 합니다.';
					amina_return($error, $wr['wr_id']);
				}
			    if(!chk_captcha()) {
					$error = '자동등록방지 숫자가 틀렸습니다.';
					amina_return($error, $wr['wr_id']);
				}
			}
		} else {
			$wr_name  = strip_tags($_POST['wr_name']);
			$wr_email = strip_tags($_POST['wr_email']);

			// 비회원의 경우 이름이 누락되는 경우가 있음
			if (!$is_member) {
			    if (!trim($wr_name)) {
					$error = '이름은 필히 입력하셔야 합니다.';
					amina_return($error, $wr['wr_id']);
				}
			}
		}

		if ($w == "c" || $w == "cu") {
		    if ($member['mb_level'] < $board['bo_comment_level']) {
				$error = '댓글을 쓸 권한이 없습니다.';
				amina_return($error, $wr['wr_id']);
			}
		} else {
			$error = 'w 값이 제대로 넘어오지 않았습니다.';
			amina_return($error, $wr['wr_id']);
		}

		// 세션의 시간 검사
		// 4.00.15 - 코멘트 수정시 연속 게시물 등록 메시지로 인한 오류 수정
		if ($w == 'c' && $_SESSION['ss_datetime'] >= (G5_SERVER_TIME - $config['cf_delay_sec']) && !$is_admin) {
			$error = '너무 빠른 시간내에 댓글을 연속해서 올릴 수 없습니다.';
			amina_return($error, $wr['wr_id']);
		}

		set_session("ss_datetime", G5_SERVER_TIME);

		if(!AMINA) {
			// 동일내용 연속 등록 불가
			$sql = " select MD5(CONCAT(wr_ip, wr_subject, wr_content)) as prev_md5 from $write_table ";
			if ($w == "cu")
				$sql .= " where wr_id <> '$comment_id' ";
			$sql .= " order by wr_id desc limit 1 ";
			$row = sql_fetch($sql);
			$curr_md5 = md5($_SERVER['REMOTE_ADDR'].$wr_subject.$wr_content);
			if ($row['prev_md5'] == $curr_md5 && $w != 'cu' && !$is_admin) {
				$error = '동일한 내용을 연속해서 등록할 수 없습니다.';
				amina_return($error, $wr['wr_id']);
			}

			if (!$is_member) {
				if ($w=='' || $w=='c') {
					$key = get_session("captcha_keystring");
				    session_unregister("captcha_keystring");
				    if (!($key && $key == $_POST['wr_key'])) {
						$error = '정상적인 접근이 아닌것 같습니다.';
						amina_return($error, $wr['wr_id']);
				    }
			    }
			}
		} 

		//"인터넷옵션 > 보안 > 사용자정의수준 > 스크립팅 > Action 스크립팅 > 사용 안 함" 일 경우의 오류 처리
		//이 옵션을 사용 안 함으로 설정할 경우 어떤 스크립트도 실행 되지 않습니다.
		//if (!trim($_POST["wr_content"])) die ("내용을 입력하여 주십시오.");

		if ($member['mb_id']) {
		    $mb_id = $member['mb_id'];
			// 4.00.13 - 실명 사용일때 코멘트에 별명으로 입력되던 오류를 수정
			$wr_name = $board['bo_use_name'] ? $member['mb_name'] : $member['mb_nick'];
		    $wr_password = $member['mb_password'];
			$wr_email = $member['mb_email'];
		    $wr_homepage = $member['mb_homepage'];
		} else {
			$mb_id = '';
			$wr_password = sql_password($wr_password);
		}

		if ($w == "c") { // 코멘트 입력
		    /*
			if ($member[mb_point] + $board[bo_comment_point] < 0 && !$is_admin)
			    alert("보유하신 포인트(".number_format($member[mb_point]).")가 없거나 모자라서 코멘트쓰기(".number_format($board[bo_comment_point]).")가 불가합니다.\\n\\n포인트를 적립하신 후 다시 코멘트를 써 주십시오.");
			*/
			// 댓글쓰기 포인트설정시 회원의 포인트가 음수인 경우 코멘트를 쓰지 못하던 버그를 수정 (곱슬최씨님)
		    $tmp_point = ($member['mb_point'] > 0) ? $member['mb_point'] : 0;
			if ($tmp_point + $board['bo_comment_point'] < 0 && !$is_admin) {
				$error = "보유하신 MP(".number_format($member['mb_point']).")가 없거나 모자라서 댓글쓰기(".number_format($board['bo_comment_point']).")가 불가합니다.";
				amina_return($error, $wr['wr_id']);
			}

		    // 댓글 답변
			if ($comment_id) {
			    $sql = " select wr_id, wr_comment, wr_comment_reply from $write_table 
				          where wr_id = '$comment_id' ";
		        $reply_array = sql_fetch($sql);
			    if (!$reply_array['wr_id']) {
					$error = '답변할 댓글이 없습니다.\\n\\n답변하는 동안 댓글이 삭제되었을 수 있습니다.';
					amina_return($error, $wr['wr_id']);
				}
	
				$tmp_comment = $reply_array['wr_comment'];
	
		        if (strlen($reply_array['wr_comment_reply']) == 5) {
					$error = '더 이상 답변하실 수 없습니다.\\n\\n답변은 5단계 까지만 가능합니다.';
					amina_return($error, $wr['wr_id']);
				}

		        $reply_len = strlen($reply_array['wr_comment_reply']) + 1;
			    if ($board['bo_reply_order']) {
				    $begin_reply_char = "A";
		            $end_reply_char = "Z";
			        $reply_number = +1;
				    $sql = " select MAX(SUBSTRING(wr_comment_reply, $reply_len, 1)) as reply 
					           from $write_table 
						      where wr_parent = '$wr_id' 
						        and wr_comment = '$tmp_comment'
							    and SUBSTRING(wr_comment_reply, $reply_len, 1) <> '' ";
		        } else {
		            $begin_reply_char = "Z";
			        $end_reply_char = "A";
				    $reply_number = -1;
					$sql = " select MIN(SUBSTRING(wr_comment_reply, $reply_len, 1)) as reply 
		                       from $write_table 
			                  where wr_parent = '$wr_id' 
				                and wr_comment = '$tmp_comment'
					           and SUBSTRING(wr_comment_reply, $reply_len, 1) <> '' ";
		        }
		        if ($reply_array['wr_comment_reply']) 
			        $sql .= " and wr_comment_reply like '{$reply_array['wr_comment_reply']}%' ";
		        $row = sql_fetch($sql);

		        if (!$row['reply']) {
			        $reply_char = $begin_reply_char;
				} else if ($row['reply'] == $end_reply_char) { // A~Z은 26 입니다.
					$error = '더 이상 답변하실 수 없습니다.\\n\\n답변은 26개 까지만 가능합니다.';
					amina_return($error, $wr['wr_id']);
				} else {
				    $reply_char = chr(ord($row['reply']) + $reply_number);
				}

		        $tmp_comment_reply = $reply_array['wr_comment_reply'] . $reply_char;

			} else {

				$sql = " select max(wr_comment) as max_comment from $write_table 
					      where wr_parent = '$wr_id' and wr_is_comment = 1 ";
				$row = sql_fetch($sql);
			    //$row[max_comment] -= 1;
		        $row['max_comment'] += 1;
			    $tmp_comment = $row['max_comment'];
				$tmp_comment_reply = '';
		    }

			$wr_subject = get_text(stripslashes($wr['wr_subject']));

			// SNS 등록
		    include_once(AMINA_PATH.'/write_comment_update.sns.php');

		    $sql = " insert into $write_table
			            set ca_name = '{$wr['ca_name']}',
				            wr_option = '$wr_secret',
					        wr_num = '{$wr['wr_num']}',
					        wr_reply = '',
						    wr_parent = '$wr_id',
					        wr_is_comment = '1',
		                    wr_comment = '$tmp_comment',
			                wr_comment_reply = '$tmp_comment_reply',
				            wr_subject = '$wr_subject',
					        wr_content = '$wr_content',
						    mb_id = '$mb_id',
			                wr_password = '$wr_password',
				            wr_name = '$wr_name',
					        wr_email = '$wr_email',
				            wr_homepage = '$wr_homepage',
							wr_datetime = '".G5_TIME_YMDHIS."',
						    wr_last = '',
					        wr_ip = '{$_SERVER['REMOTE_ADDR']}',
							wr_facebook_user = '$wr_facebook_user',
							wr_twitter_user  = '$wr_twitter_user',
							wr_1 = '$wr_1',
			                wr_2 = '$wr_2',
				            wr_3 = '$wr_3',
					        wr_4 = '$wr_4',
				            wr_5 = '$wr_5',
					        wr_6 = '$wr_6',
				            wr_7 = '$wr_7',
					        wr_8 = '$wr_8',
			                wr_9 = '$wr_9',
				            wr_10 = '$wr_10' ";
		    sql_query($sql);

		    $comment_id = mysql_insert_id();

		    // 원글에 댓글수 증가 & 마지막 시간 반영
		    sql_query(" update $write_table set wr_comment = wr_comment + 1, wr_last = '".G5_TIME_YMDHIS."' where wr_id = '$wr_id' ");

		    // 새글 INSERT
		    sql_query(" insert into {$g5['board_new_table']} ( bo_table, wr_id, wr_parent, bn_datetime, mb_id ) values ( '$bo_table', '$comment_id', '$wr_id', '".G5_TIME_YMDHIS."', '{$member['mb_id']}' ) ");

		    // 댓글 1 증가
			sql_query(" update {$g5['board_table']} set bo_count_comment = bo_count_comment + 1 where bo_table = '$bo_table' ");

		    // 포인트 부여
			insert_point($member['mb_id'], $board['bo_comment_point'], "{$board['bo_subject']} {$wr_id}-{$comment_id} {$point_log}쓰기", $bo_table, $comment_id, $point_log);

		    // 메일발송 사용
			if ($config['cf_email_use'] && $board['bo_use_email']) {
			    // 관리자의 정보를 얻고
				$super_admin = get_admin('super');
			    $group_admin = get_admin('group');
		        $board_admin = get_admin('board');

		        $wr_subject = get_text(stripslashes($wr['wr_subject']));
				if(AMINA) {
			        $wr_content = nl2br(get_text(stripslashes("원글\n{$wr['wr_subject']}\n\n\n댓글\n$wr_content")));
				    $warr = array( ''=>'입력', 'u'=>'수정', 'r'=>'답변', 'c'=>'댓글 ', 'cu'=>'댓글 수정' );
				} else {
				    $wr_content = nl2br(get_text(stripslashes("----- 원글 -----\n\n{$wr['wr_subject']}\n\n\n----- 코멘트 -----\n\n$wr_content")));
			        $warr = array( ""=>"입력", "u"=>"수정", "r"=>"답변", "c"=>"코멘트", "cu"=>"코멘트 수정" );
				}
			    $str = $warr[$w];

		        $subject = "'{$board['bo_subject']}' 게시판에 {$str}글이 올라왔습니다.";
			    // 4.00.15 - 메일로 보내는 코멘트의 바로가기 링크 수정
			    $link_url = G5_BBS_URL."/board.php?bo_table=".$bo_table."&wr_id=".$wr_id.$qstr."#c_".$comment_id;

		        include_once(G5_PATH.'/lib/mailer.lib.php');

		        ob_start();
			    include_once (G5_BBS_PATH.'/write_update_mail.php');
				$content = ob_get_contents();
		        ob_end_clean();

		        $array_email = array();
			    // 게시판관리자에게 보내는 메일
		        if ($config['cf_email_wr_board_admin']) $array_email[] = $board_admin['mb_email'];
			    // 게시판그룹관리자에게 보내는 메일
			    if ($config['cf_email_wr_group_admin']) $array_email[] = $group_admin['mb_email'];
			    // 최고관리자에게 보내는 메일
		        if ($config['cf_email_wr_super_admin']) $array_email[] = $super_admin['mb_email'];

			    // 옵션에 메일받기가 체크되어 있고, 게시자의 메일이 있다면
				if (strstr($wr['wr_option'], "mail") && $wr['wr_email']) {
					// 원글 메일발송에 체크가 되어 있다면
				    if ($config['cf_email_wr_write']) $array_email[] = $wr['wr_email'];

			        // 코멘트 쓴 모든이에게 메일 발송이 되어 있다면 (자신에게는 발송하지 않는다)
				    if ($config['cf_email_wr_comment_all']) {
					    $sql = " select distinct wr_email from $write_table
				                  where wr_email not in ( '{$wr['wr_email']}', '{$member['mb_email']}', '' )
					                and wr_parent = '$wr_id' ";
				        $result = sql_query($sql);
					    while ($row=sql_fetch_array($result))
						    $array_email[] = $row['wr_email'];
				    }
			    }

		        // 중복된 메일 주소는 제거
			    $unique_email = array_unique($array_email);
				$unique_email = array_values($unique_email);
		        for ($i=0; $i<count($unique_email); $i++) {
			        mailer($wr_name, $wr_email, $unique_email[$i], $subject, $content, 1);
				}
		    }
		} else if ($w == "cu") { // 코멘트 수정
		    $sql = " select mb_id, wr_comment, wr_comment_reply from $write_table 
			          where wr_id = '$comment_id' ";
		    $comment = $reply_array = sql_fetch($sql);
		    $tmp_comment = $reply_array['wr_comment'];

		    $len = strlen($reply_array['wr_comment_reply']);
			if ($len < 0) $len = 0; 
			$comment_reply = substr($reply_array['wr_comment_reply'], 0, $len);
			//print_r2($GLOBALS); exit;

		    if ($is_admin == "super") // 최고관리자 통과 
			    ; 
		    else if ($is_admin == "group") { // 그룹관리자 
			    $mb = get_member($comment['mb_id']); 
				if ($member['mb_id'] == $group['gr_admin']) { // 자신이 관리하는 그룹인가? 
					if ($member['mb_level'] >= $mb['mb_level']) { // 자신의 레벨이 크거나 같다면 통과 
					    ; 
			        } else {
						$error = '그룹관리자의 권한보다 높은 회원의 댓글이므로 수정할 수 없습니다.';
						amina_return($error, $wr['wr_id']);
					}
		        } else {
					$error = '자신이 관리하는 그룹의 게시판이 아니므로 댓글를 수정할 수 없습니다.';
					amina_return($error, $wr['wr_id']);
				}
		    } else if ($is_admin == "board") { // 게시판관리자이면 
			    $mb = get_member($comment['mb_id']); 
				if ($member['mb_id'] == $board['bo_admin']) { // 자신이 관리하는 게시판인가? 
					if ($member['mb_level'] >= $mb['mb_level']) { // 자신의 레벨이 크거나 같다면 통과 
			            ; 
				    } else {
						$error = '게시판관리자의 권한보다 높은 회원의 댓글이므로 수정할 수 없습니다.';
						amina_return($error, $wr['wr_id']);
					}
			    } else {
					$error = '자신이 관리하는 게시판이 아니므로 댓글을 수정할 수 없습니다.';
					amina_return($error, $wr['wr_id']);
				}
			} else if ($member['mb_id']) { 
			    if ($member['mb_id'] != $comment['mb_id']) {
					$error = '자신의 글이 아니므로 수정할 수 없습니다.';
					amina_return($error, $wr['wr_id']);
				}
		    } 

		    $sql = " select count(*) as cnt from $write_table
			          where wr_comment_reply like '$comment_reply%'
				        and wr_id <> '$comment_id'
					    and wr_parent = '$wr_id'
					    and wr_comment = '$tmp_comment' 
			            and wr_is_comment = 1 ";
		    $row = sql_fetch($sql);
		    if ($row['cnt'] && !$is_admin) {
				$error = '이 댓글과 관련된 답변댓글이 존재하므로 수정 할 수 없습니다.';
				amina_return($error, $wr['wr_id']);			
			}

		    $sql_ip = "";
		    if (!$is_admin)
			    $sql_ip = " , wr_ip = '{$_SERVER['REMOTE_ADDR']}' ";

		    $sql_secret = "";
		    if ($wr_secret)
			    $sql_secret = " , wr_option = '$wr_secret' ";

		    $sql = " update $write_table
			            set wr_subject = '$wr_subject',
				            wr_content = '$wr_content',
					        wr_1 = '$wr_1',
						    wr_2 = '$wr_2',
		                    wr_3 = '$wr_3',
			                wr_4 = '$wr_4',
				            wr_5 = '$wr_5',
					        wr_6 = '$wr_6',
						    wr_7 = '$wr_7',
		                    wr_8 = '$wr_8',
			                wr_9 = '$wr_9',
				            wr_10 = '$wr_10',
					        wr_option = '$wr_option'
						    $sql_ip
		                    $sql_secret
			          where wr_id = '$comment_id' ";
		    sql_query($sql);
		}

		// 사용자 코드 실행
		@include_once($board_skin_path.'/write_comment_update.skin.php');
		@include_once($board_skin_path.'/write_comment_update.tail.skin.php');

		if(AMINA) delete_cache_latest($bo_table);
	}
}

//js 미사용시 이동
if($move_href || $frame) amina_return('', $wr['wr_id'], $frame);

//원글을 글내용으로...
$view = $wr;
$wr_id = $wr['wr_id'];

include_once(AMINA_PATH.'/comment.load.php');

?>